package 
{
	import com.gskinner.utils.SWFBridgeAS3;
	
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.URLRequest;

	[SWF( width='600', height='400', frameRate='30', backgroundColor='#000000' )]

	public class App extends Sprite
	{
		public static const BRIDGE_NAME:String			= 'YouTubePlayerWrapperBridge';
		
		private var player:Loader;
		private var bridge:SWFBridgeAS3;
		private var videoId:String;
		private var loaded:Boolean;
		
		public function App()
		{
			init( 'f8nNOQOh7dc' );
		}
		
		public function init(videoId:String):void
		{
			this.videoId = videoId;
			
			if ( !loaded )
			{
				var request:URLRequest = new URLRequest( 'assets/swf/YouTubePlayerWrapper.swf' );
				
				player = new Loader();
				
				addChild( player );
				
				player.contentLoaderInfo.addEventListener( Event.INIT, handlePlayerLoadedComplete );
				
				player.load( request );
			}
			else
			{
				handlePlayerLoadedComplete();
			}
		}	
		
		public function play(videoId:String):void
		{
			bridge.send( 'playVideo', videoId, stage.stageWidth, stage.stageHeight, false, null, false );
		}
		
		public function stop():void
		{
			bridge.send( 'stopVideo' );
		}
		
		public function handlePlayerLoadedComplete(e:Event=null):void
		{						
			if ( bridge )
			{
				handleBridgeConnect(); 
			}
			else
			{
				bridge = new SWFBridgeAS3( BRIDGE_NAME, this );
			
				bridge.addEventListener( Event.CONNECT, handleBridgeConnect );				
			}
		}
		
		public function sendEvent(e:String):void
		{
			trace( e );
		}
		
		private function handleBridgeConnect(e:Event=null):void
		{			
			loaded = true;
			
			play( videoId );
		}	
	}
}
