import com.gskinner.utils.SWFBridgeAS2;

import mx.utils.Delegate;

import YouTubePlayer;
import YouTubePlayerEvent;

class YouTubePlayerWrapper
{
	static var BRIDGE_NAME:String								= 'YouTubePlayerWrapperBridge';
	
	private var parent:MovieClip;
	private var player:YouTubePlayer;
	private var bridge:SWFBridgeAS2;
	
	public function YouTubePlayerWrapper(parent:MovieClip)
	{
		Stage.scaleMode = 'noScale';
		Stage.align = 'TL';

		System.security.allowDomain( '*' );
		System.security.allowDomain( 'www.youtube.com' );
		System.security.allowDomain( 'youtube.com' );
		System.security.allowDomain( 's.ytimg.com' );
		System.security.allowDomain( 'i.ytimg.com' );
		
		this.parent = parent;
		
		init();
	}
	
	private function init():Void
	{
		var playerHolder:MovieClip = parent.createEmptyMovieClip( 'playerHolder', parent.getNextHighestDepth() );
		
		bridge = new SWFBridgeAS2( BRIDGE_NAME, this );
		
		bridge.addEventListener( 'connect', this );

		player = new YouTubePlayer( playerHolder );
		
		player.addEventListener( YouTubePlayerEvent.PLAYER_ENDED, Delegate.create( this, sendEvent ) );
		player.addEventListener( YouTubePlayerEvent.PLAYER_PLAYING, Delegate.create( this, sendEvent ) );
		player.addEventListener( YouTubePlayerEvent.PLAYER_PAUSED, Delegate.create( this, sendEvent ) );
		player.addEventListener( YouTubePlayerEvent.PLAYER_BUFFERING, Delegate.create( this, sendEvent ) );
		player.addEventListener( YouTubePlayerEvent.PLAYER_QUEUED, Delegate.create( this, sendEvent ) );
		player.addEventListener( YouTubePlayerEvent.PLAYER_NOT_STARTED, Delegate.create( this, sendEvent ) );
	}
	
	private function sendEvent(e:YouTubePlayerEvent):Void
	{	
		bridge.send( 'sendEvent', e.type );
	}
	
	public function playVideo(videoId:String, playerWidth:Number, playerHeight:Number, autoPlay:Boolean, pars:String, chromeless:Boolean):Void
	{		
		player.autoPlay = ( autoPlay !== false ? true : false );
		player.chromeless = ( chromeless ? chromeless : false );
		player.pars = ( pars ? pars : player.pars );
		player.playerWidth = ( playerWidth ? playerWidth : player.playerWidth );
		player.playerHeight = ( playerHeight ? playerHeight : player.playerHeight );

		player.init( videoId );
	}
	
	public function resizePlayer(width:Number, height:Number):Void
	{
		player.resizePlayer( width, height );
	}

	public function stopVideo():Void
	{
		player.stop();
	}
}